# a3_todo_test.py
# PUT YOUR NETID(S) HERE
# Sources/people consulted: FILL IN OR WRITE "NONE"
# PUT DATE YOU COMPLETED THIS HERE
# Skeleton authors: Lillian Lee, William  Xiao, Rhea Bansal, Kevin Cook
"""

(Skeleton for) test-case-like code



"""
import a3_classes
import a3_todo
import testcase


# globals setting things up somewhat like assignment diagram
predef1   = a3_classes.Task("SPCA shift", 3)
predef2   = a3_classes.Task("work-study", 2)
predef3   = a3_classes.Task("cure cancer", 3)
predef4   = a3_classes.Task("Study for prelims", 4)
predef5   = a3_classes.Task("Conquer enemies", 24)
todo_call = a3_classes.Task("Call mom", 1)
todo_hack = a3_classes.Task("Programming sprint", 6)
DAY_POOL = [a3_classes.Day("Monday March 2"),  # all time_slots are None
            a3_classes.Day("Monday March 9"),  # all time_slots are None
            a3_classes.Day("Ides of March"),   # all time_slots are None
            a3_classes.Day("Monday March 16")  # all time_slots are None
            ]




# Helper for checking against accidental changes in tasks
def assert_task_unchanged(task, name, length):
    """Quits with error if task.name != name or task.length != length."""
    if task.name != name or task.length != length:
        msg = "Task has unexpected attribute."
        msg += " Its name is " + task.name
        msg += " and its length is " + str(task.length)
        testcase.quit_with_error(msg)


def test_sirialize_days():
    """Runs sirialize_days; a human must check if output looks right"""

    print("Running test_sirialize_days")

    # 1. List with more than one Day. (You're not required to add more cases.)
    # make a day for some tasks
    day = a3_classes.Day("Day in the City")
    task_driveout = a3_classes.Task("Drive to NYC", 4)
    task_moma = a3_classes.Task("Visit MOMA", 2)
    task_night = a3_classes.Task("Nightlife tour", 1)
    # put tasks in day
    day.time_slots[4] = task_driveout; day.time_slots[5] = task_driveout
    day.time_slots[6] = task_driveout; day.time_slots[7] = task_driveout
    day.time_slots[12] = task_moma; day.time_slots[13] = task_moma
    day.time_slots[23] = task_night
    # make an empty day
    day2 = a3_classes.Day("Empty Day")
    # make a third day with some tasks
    day3 = a3_classes.Day("Day of Return")
    task_driveback = a3_classes.Task("Drive back from NYC", 4)
    day3.time_slots[13] = task_driveback; day3.time_slots[14] = task_driveback
    day3.time_slots[15] = task_driveback; day3.time_slots[16] = task_driveback
    daylist = [day, day2, day3]
    #
    print("Output for Day in the City, then Empty Day, then Day of Return\n\n")
    # run the function to test
    a3_todo.sirialize_days(daylist)
    # make sure nothing else changed
    assert_task_unchanged(task_driveout, "Drive to NYC", 4)
    assert_task_unchanged(task_moma, "Visit MOMA", 2)
    assert_task_unchanged(task_night, "Nightlife tour", 1)
    assert_task_unchanged(task_driveback, "Drive back from NYC", 4)

    print("*** STUDENT: eyeball the above to make sure it seems right!\n\n")
    print("Finished test_sirialize_days")



def test_num_hours_busy():
    """(Skeleton for) testing num_hours_busy"""

    # 1. One task in middle of otherwise empty day, taking up some hours
    day = a3_classes.Day("Random day")
    task = a3_classes.Task("Drive to NYC", 4)
    day.time_slots[4] = task; day.time_slots[5] = task
    day.time_slots[6] = task; day.time_slots[7] = task
    testcase.assert_equals(4, a3_todo.num_hours_busy(day))

    # STUDENT-ADDED CASES GO HERE. DO NOT DELETE THIS COMMENT.
    # Comment each testcase as above: with a number and a rationale.

    # Staff: here are some test cases to get the students to consider!
    # 2. Empty day
    # 3. Two events scheduled
    # 4. full day packed (24 hours filled)


def test_space_available():
    """Test space_available."""
    pass # STUDENTS: complete this.
    # For each test case, include a comment to number it and give your
    # rationale for including it.

    # Staff: here are some test cases to get the students to consider!

    # Empty Day Tests
    # make a list of many None objects
    # 1. task length of 1
    # 2. task length of multiple hours
    # 3. task that takes up whole time period

    # add a single task that takes multiple hours
    # 4. still free later in the day even after adding event
    # 5. not free during one hour increments during event
    # 6. not free over larger segments during that task (but still contained within)
    # 7. not free over whole time block of task + more

    # Add a second task to task list from 5AM - 7AM
    # 8. not free over timeslots that span multiple events


def test_add_task():
    """
    Test cases for a3_todo.task, using roughly the diagram setup as
    a test case.
    """

    print("Running test_add_task")
    # STUDENTS: Document your testcases with rationales like this in the
    # test functions you write for this assignment.

    #1: successful add in middle of completely empty day
    a3_todo.add_task(DAY_POOL[0], predef1, 3)

    #2: successful add to middle of gap in day
    a3_todo.add_task(DAY_POOL[0], predef4, 10)

    #3: successful add going up to the very end of a day
    a3_todo.add_task(DAY_POOL[0], predef3, 21)

    #4: successful add to very beginning of completely empty day
    a3_todo.add_task(DAY_POOL[1], predef2, 0)

    #5: successful add of task filling an entire empty day
    a3_todo.add_task(DAY_POOL[3], predef5, 0)

    ##### STUDENT-ADDED ACTIONS GO HERE. DO NOT DELETE THIS COMMENT


    #### CHECKS WHETHER RESULTS == EXPECTED.  DO NOT DELETE THIS COMMENT.

    # Things that should not have changed
    assert_task_unchanged(predef1, "SPCA shift", 3)
    assert_task_unchanged(predef2, "work-study", 2)
    assert_task_unchanged(predef3, "cure cancer", 3)
    assert_task_unchanged(predef4, "Study for prelims", 4)
    assert_task_unchanged(predef5, "Conquer enemies", 24)
    assert_task_unchanged(todo_call, "Call mom", 1)
    assert_task_unchanged(todo_hack, "Programming sprint", 6)
    testcase.assert_equals(4, len(DAY_POOL))

    # Check day 0
    day0 = DAY_POOL[0]
    testcase.assert_equals("Monday March 2", day0.name)
    testcase.assert_equals(24, len(day0.time_slots))

    for i in list(range(0,3)) + list(range(6,10)) + list(range(14,21)):
        testcase.assert_equals(None, day0.time_slots[i])
    for i in range(3,6):
        testcase.assert_equals(predef1, day0.time_slots[i])
    for i in range(10,14):
        testcase.assert_equals(predef4, day0.time_slots[i])
    for i in range(21,24):
        testcase.assert_equals(predef3, day0.time_slots[i])
    testcase.assert_equals(3, day0.num_tasks_scheduled)

    # Check day 1
    day1 = DAY_POOL[1]
    testcase.assert_equals("Monday March 9", day1.name)
    testcase.assert_equals(24, len(day1.time_slots))
    for empty in range(2,24):
        testcase.assert_equals(None, day1.time_slots[empty])
    for i in range(0,2):
        testcase.assert_equals(predef2, day1.time_slots[i])
    testcase.assert_equals(1, day1.num_tasks_scheduled)

    # Check day 2
    day2 = DAY_POOL[2]
    testcase.assert_equals("Ides of March", day2.name)
    testcase.assert_equals(24, len(day2.time_slots))
    for slot in day2.time_slots:
        testcase.assert_equals(None, slot)
    testcase.assert_equals(0, day2.num_tasks_scheduled)

    # Check day 3
    day3 = DAY_POOL[3]
    testcase.assert_equals("Monday March 16", day3.name)
    testcase.assert_equals(24, len(day3.time_slots))
    for task in day3.time_slots:
        testcase.assert_equals(predef5, task)
    testcase.assert_equals(1, day3.num_tasks_scheduled)

    # STUDENT-ADDED ASSERTIONS GO HERE. DO NOT DELETE THIS COMMENT.
    print("Finished test_add_task")


if __name__ == '__main__':

    test_sirialize_days()
    test_num_hours_busy()
    test_space_available()
    test_add_task()
    print("All test cases passed.  That's one task done with!")


